unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses WbemScripting_TLB, activex;

procedure getProcesses(owner:TComponent; RemoteMachine,RemoteUser,RemotePassword:string; Processes:TStrings);
var
  Locator: TSWbemLocator;

  Services:   ISWbemServices;
  ObjectSet:  ISWbemObjectSet;
  SObject:    ISWbemObject;
  propSet :   ISWbemPropertySet;
  SProp:      ISWbemProperty;
  propEnum,
  Enum:       IEnumVariant;

  tempObj1,
  tempObj2,
  spropvalue: OleVariant;
  Count,
  Value:      Cardinal;

  sValue:     String;
  i:byte;
  tmp:string;
begin
  Processes.Clear;
  Processes.BeginUpdate;
  try
    Locator:=TSWbemLocator.Create(owner);
    try
      if RemoteMachine='' then
        RemoteMachine:='.';// local machine
      Services := Locator.ConnectServer(RemoteMachine, 'root\CIMV2', RemoteUser, RemotePassword, '',
        '', 0, nil);
      try
        ObjectSet := Services.InstancesOf('Win32_Process', wbemFlagReturnImmediately or wbemQueryFlagShallow, nil);
        try
          Enum :=  (ObjectSet._NewEnum) as IEnumVariant;
          try
            i:=0;
            while (Enum.Next(1, tempObj1, Value) = S_OK) do
            try
              tmp:='';
              SObject := IUnknown(tempObj1) as SWBemObject;
              try
                propSet := SObject.Properties_;
                propEnum := (propSet._NewEnum) as IEnumVariant;
                try
                  while (propEnum.Next(1, tempObj2, Value) = S_OK) do
                  try
                    SProp := IUnknown(tempObj2) as SWBemProperty;
                    if (SProp.Name<>'Name') and (SProp.Name<>'ProcessId')
                      and (SProp.Name<>'ParentProcessId') and (SProp.Name<>'CreationDate') and (SProp.Name<>'ExecutablePath') then
                        continue;
                    // now get the value of the property
                    sValue := '';
                    spropvalue:=SProp.Get_Value;
                    try
                      if VarIsNull(spropvalue) then
                        sValue := '<empty>'
                      else
                        case SProp.CIMType of
                          wbemCimtypeSint8, wbemCimtypeUint8, wbemCimtypeSint16, wbemCimtypeUint16,
                          wbemCimtypeSint32, wbemCimtypeUint32, wbemCimtypeSint64:
                            sValue := IntToStr(spropvalue);
                          wbemCimtypeString, wbemCimtypeUint64:
                            if VarIsArray(spropvalue) then
                            begin
                              if VarArrayHighBound(spropvalue, 1) > 0 then
                                for Count := 1 to VarArrayHighBound(spropvalue, 1) do
                                  sValue := sValue + ' ' + spropvalue[Count];
                            end
                            else
                              sValue :=  spropvalue;
                          wbemCimtypeDatetime:sValue:=spropvalue//DateTimeToStr(spropvalue)
                        else
                          Exception.Create('Unknown type');
                        end;
                    finally
                      spropvalue:=unassigned;
                    end;
                    case i of
                      0:tmp:=tmp+' [CreationDate='+sValue+']';
                      1:tmp:=tmp+' [Path='+sValue+']';
                      2:tmp:=sValue+tmp;
                      3:tmp:=tmp+' [Parent PID='+sValue+']';
                      4:tmp:=tmp+' [PID='+sValue+']';
                    end;

                    i:=(i+1) mod 5;
                    if i=0 then
                      processes.add(tmp);
                  finally
                    sProp:=nil;
                    tempObj2:=NULL;
                  end;
                finally
                  propEnum:=nil;
                  propSet:=nil;
                end;
              finally
                sObject:=nil;
              end;
            finally
              tempObj2:=NULL;
            end;
          finally
            enum.Reset;
            enum:=nil;
          end;
        finally
          objectSet:=nil;
        end;
      finally
        Services:=nil;
      end;
    finally
      try
        locator.Disconnect;
      finally
        freeandnil(Locator);
      end;
    end;
  finally
    processes.EndUpdate;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  statusbar1.simpletext:='querying WMI....';
  getProcesses(self, '', '', '', listbox1.items);
  statusbar1.simpletext:='done';
end;

end.
